
#include <stdio.h>
#include <string.h>

#define PEINDEX_POSITION 0x3C
#define CHARACTERISTICS_OFFSET 0x16

int main(int argc, char *argv[])
{
	FILE *fPEFile;
	char *pszFilename;
	unsigned int uiPEHEADERIndex;
	unsigned short int wDLLCHARACTERISTICS;
	int iIter;

	if (1 == argc)
	{
		fprintf(stderr, "Usage: setcharacteristics file\n");
		return -1;
	}

	pszFilename = argv[argc-1];
	if ((fPEFile = fopen(pszFilename, "r+b")) == NULL)
	{
		fprintf(stderr, "Error: opening file %s\n", pszFilename);
		return -1;
	}

	if (fseek(fPEFile, PEINDEX_POSITION, 0) != 0)
	{
		fprintf(stderr, "Error: fseek file %s %04X\n", pszFilename, PEINDEX_POSITION);
		fclose(fPEFile);
		return -1;
	}

	if (fread(&uiPEHEADERIndex, sizeof(uiPEHEADERIndex), 1, fPEFile) != 1)
	{
		fprintf(stderr, "Error: reading file %s\n", pszFilename);
		fclose(fPEFile);
		return -1;
	}

	if (fseek(fPEFile, uiPEHEADERIndex + CHARACTERISTICS_OFFSET, 0) != 0)
	{
		fprintf(stderr, "Error: fseek file %s %04X\n", pszFilename, uiPEHEADERIndex + CHARACTERISTICS_OFFSET);
		fclose(fPEFile);
		return -1;
	}

	if (fread(&wDLLCHARACTERISTICS, sizeof(wDLLCHARACTERISTICS), 1, fPEFile) != 1)
	{
		fprintf(stderr, "Error: reading file %s\n", pszFilename);
		fclose(fPEFile);
		return -1;
	}

	printf("Original CHARACTERISTICS = 0x%04X\n", wDLLCHARACTERISTICS);

    wDLLCHARACTERISTICS |= 0x2000;

    if (fseek(fPEFile, uiPEHEADERIndex + CHARACTERISTICS_OFFSET, 0) != 0)
	{
		fprintf(stderr, "Error: fseek file %s %04X\n", pszFilename, uiPEHEADERIndex + CHARACTERISTICS_OFFSET);
		fclose(fPEFile);
		return -1;
	}

	if (fwrite(&wDLLCHARACTERISTICS, sizeof(wDLLCHARACTERISTICS), 1, fPEFile) != 1)
	{
		fprintf(stderr, "Error: writing file %s\n", pszFilename);
		fclose(fPEFile);
		return -1;
	}

	printf("Updated  CHARACTERISTICS = 0x%04X\n", wDLLCHARACTERISTICS);

	fclose(fPEFile);

	return 0;
}
